// 2-3  (    )
//   

#include<stdio.h>
#include<stdlib.h>
#include<memory.h>
#include<conio.h>

#define NODE_LIMIT 1000		//    
#define LIST_LIMIT 1000		//    
#define CHECK_SIZE 1000		//   
#define VOID  -1			//   
#define FREE  -2			//   
#define LIST_SIZE 3			//   (     )

#if LIST_SIZE<2 
#error
#endif

struct cell_st{ int v; int p;};					//!<  
struct node_st{cell_st arr[3];};				//!<   
struct list_st{int count; int v[LIST_SIZE];};	//!<  
// v   
// p   
// count  

int tree_root;	//!<    
int tree_h;		//!<  
node_st nodes[NODE_LIMIT];	//!<   
list_st list[LIST_LIMIT];	//!<   

//=====  =====

//!  
void Alarm()
{
	printf("out of memory\n");
	getchar();
	exit(-1);
}

//!   
bool isFreeNode(int index)
{
	return nodes[index].arr[0].p==FREE;
}

//!   
bool isFreeList(int index)
{
	return list[index].count==FREE;
}

//!   
int NewNode()
{
	int n,m;
	for(n=0; n<NODE_LIMIT; n++) if(isFreeNode(n)) {
		for(m=0; m<3; m++) nodes[n].arr[m].p=VOID;
		return n;
	}
	Alarm();
	return -1;
}

//!   
int NewList()
{
	int n;
	for(n=0; n<LIST_LIMIT; n++) if(isFreeList(n)) {
		list[n].count=0;
		return n;
	}
	Alarm();
	return -1;
}

//!  
void FreeNode(int index)
{
	nodes[index].arr[0].p=FREE;
}

//!  
void FreeList(int index)
{
	list[index].count=FREE;
}


//!  
void Init()
{
	tree_root=VOID; tree_h=0; int n;
	for(n=0; n<NODE_LIMIT; n++) FreeNode(n);
	for(n=0; n<LIST_LIMIT; n++) FreeList(n);
}

//=====    =====

//!  
//! \param tree_index   
//! \param sl  ,     
//! \result   
inline int SplitList(int tree_index,int slack)
{
	int i,n=NewList();
	for(i=0; i<LIST_SIZE/2; i++) list[n].v[i]=list[tree_index].v[i+(LIST_SIZE+1)/2];
	list[n].v[i++]=slack; list[n].count=i;
	list[tree_index].count=(LIST_SIZE+1)/2;
	return n;
}


//!  
//! \param tree_index   
//! \param sl  ,     
//! \result   
inline int SplitNode(int tree_index,cell_st slack)
{
	int i=NewNode();
	nodes[i].arr[0]=nodes[tree_index].arr[2];
	nodes[i].arr[1]=slack;	
	nodes[tree_index].arr[2].p=VOID;
	return i;
}



//!    
//! \param tree_index  
//! \param value  
//! \result !=VOID   ,     
inline int InsertToList(int tree_index,int value)
{
	int i,n;
	int slack;
	for(i=0; i<list[tree_index].count; i++) {
		if(list[tree_index].v[i]==value) return VOID;
		if(list[tree_index].v[i]>value) break;
	}
	slack=list[tree_index].v[LIST_SIZE-1];
	for(n=LIST_SIZE-1; n>i; n--) list[tree_index].v[n]=list[tree_index].v[n-1];
	if(i<LIST_SIZE) list[tree_index].v[i]=value; else slack=value;
	list[tree_index].count++;
	if(list[tree_index].count<=LIST_SIZE) return VOID;
	return SplitList(tree_index,slack);
}

//!    
//! \param tree_index  
//! \param i      
//! \param ref  
//! \param min   
//! \result !=VOID   ,     
inline int InsertToNode(int tree_index,int i,int ref,int min)
{
	int n;
	cell_st slack_n;
	slack_n=nodes[tree_index].arr[2];
	for(n=1; n>i; n--) nodes[tree_index].arr[n+1]=nodes[tree_index].arr[n];	
	if(i<2) nodes[tree_index].arr[i+1].p=ref,nodes[tree_index].arr[i+1].v=min; 
	else slack_n.p=ref,slack_n.v=min;
	if(slack_n.p==VOID) return VOID;
	return SplitNode(tree_index,slack_n);
}

//!        (   )
//! \param tree_index
//! \param depth
//! \result  
int GetCount(int tree_index,int depth)
{
	int n;
	if(depth==tree_h) return list[tree_index].count;
	for(n=0; n<3; n++) if(nodes[tree_index].arr[n].p==VOID) break;
	return n;
}


//!   
//! \param i1   ( )
//! \param i2   ( )
inline void MergeList(int i1,int i2)
{
	int n,m;
	n=list[i1].count;
	for(m=0; m<list[i2].count && n<LIST_SIZE; m++,n++) list[i1].v[n]=list[i2].v[m];
	list[i1].count=n;
	FreeList(i2);
}

//!   
//! \param i1   ( )
//! \param i2   ( )
inline void MergeNode(int i1,int i2)
{
	int n,m;
	for(n=0; n<3; n++) if(nodes[i1].arr[n].p==VOID) break;
	for(m=0; m<3 && n<3;) nodes[i1].arr[n++]=nodes[i2].arr[m++];
	FreeNode(i2);
}



//!    
//! \param tree_index    
//! \param i   
inline RemoveFromNode(int tree_index,int i)
{
	int n;
	for(n=i; n<2; n++) nodes[tree_index].arr[n]=nodes[tree_index].arr[n+1];
	nodes[tree_index].arr[2].p=VOID;

}

//!   
inline void PourNodeL(int index1,int index2)
{
	int n; //,min=nodes[from].arr[0].v;
	if(nodes[index1].arr[2].p!=VOID) _asm { int 3 }
	for(n=0; n<3; n++) if(nodes[index1].arr[n].p==VOID) break;
	nodes[index1].arr[n]=nodes[index2].arr[0];
	RemoveFromNode(index2,0);
}

//!   
inline void PourNodeR(int index1,int index2)
{
	int n;
	if(nodes[index2].arr[2].p!=VOID) _asm { int 3 }
	for(n=2; n; n--) if(nodes[index1].arr[n].p!=VOID) break;
	InsertToNode(index2,-1,nodes[index1].arr[n].p,nodes[index1].arr[n].v);
	nodes[index1].arr[n].p=VOID;
}

//!   
inline void PourListL(int index1,int index2)
{
	int n;
	list[index1].v[list[index1].count++]=list[index2].v[0];
	for(n=1; n<list[index2].count; n++) list[index2].v[n-1]=list[index2].v[n];
	list[index2].count--;
}

//!   
inline void PourListR(int index1,int index2)
{
	int n;
	for(n=list[index2].count;n;n--) list[index2].v[n]=list[index2].v[n-1]; 
	list[index1].count--; list[index2].count++;
	list[index2].v[0]=list[index1].v[list[index1].count];	
}


//=====     =====

//!  ,  
//! \param tree_index  
//! \param depth 
void Show(int tree_index,int depth)
{
	int n,m;
	if(tree_index==VOID) return;
	for(n=0; n<depth*2; n++) putchar(' ');
	if(depth==tree_h) {
		printf("l%d:",tree_index);
		for(n=0; n<list[tree_index].count; n++) printf(" %d",list[tree_index].v[n]);
		putchar('\n');
		return;
	}
	printf("n%d: ",tree_index);
	if(nodes[tree_index].arr[0].p==VOID) {printf("empty\n");return;}
	for(m=0; m<3; m++) {
		if(nodes[tree_index].arr[m].p==VOID) break;
		if(m) printf("[%d]",nodes[tree_index].arr[m].v);
		printf("%d",nodes[tree_index].arr[m].p);
	}
	putchar('\n');
	for(n=0; n<3; n++) Show(nodes[tree_index].arr[n].p,depth+1);
}

//!  ,  
//! \param tree_index    
//! \param depth 
//! \param value  
//! \result     
int InsertSub(int tree_index,int depth,int value)
{
	static int min1,min2;
	int n,m,i; 
	if(depth==tree_h) {	
		//     
		i=InsertToList(tree_index,value); 
		min1=list[tree_index].v[0];
		if(i==VOID) return VOID;
		min2=list[i].v[0];
		goto exit;
	}
	//           (    )
	min1=nodes[tree_index].arr[0].v;
	for(i=0; i<3; i++) {	
		if(nodes[tree_index].arr[i].p==VOID) break;
		if(value==nodes[tree_index].arr[i].v) return VOID;
		if(value<nodes[tree_index].arr[i].v) break;
	}
	if(i) i--;
	m=InsertSub(nodes[tree_index].arr[i].p,depth+1,value); //   
	nodes[tree_index].arr[i].v=min1;
	min1=nodes[tree_index].arr[0].v;
	if(m==VOID) return VOID;
	//     
	i=InsertToNode(tree_index,i,m,min2); 
	if(i==VOID) return VOID;
	min2=nodes[i].arr[0].v;
exit:
	if(depth) return i;	//   ,    .
	n=NewNode(); tree_h++;
	nodes[n].arr[0].p=tree_root;
	nodes[n].arr[1].p=i;
	nodes[n].arr[0].v=min1;
	nodes[n].arr[1].v=min2;
	tree_root=n;
	return VOID;
}


//!  ,  
//! \param tree_index   
//! \param depth 
//! \param value 
void RemoveSub(int tree_index,int depth,int value)
{
	static int min;
	int n,i1,i2;
	int count1,count2;	//       
	int ref1,ref2;		//     
	if(depth==tree_h) {	
		//   ,    
		for(n=0; n<list[tree_index].count; n++) if(list[tree_index].v[n]==value) break;
		if(n<list[tree_index].count) {
			for(;n<LIST_SIZE-1; n++) list[tree_index].v[n]=list[tree_index].v[n+1];
			list[tree_index].count--;
		}
		min=list[tree_index].v[0];
		return;
	}
	//     ,     
	for(i1=0; i1<3; i1++) {	
		if(value<nodes[tree_index].arr[i1].v || nodes[tree_index].arr[i1].p==VOID) break;
	}
	i1--; if(i1<0) return;
	RemoveSub(nodes[tree_index].arr[i1].p,depth+1,value); //   
	nodes[tree_index].arr[i1].v=min;
	//      (    )
	switch(i1) {
	case 0: i2=1; break;
	case 1: if(nodes[tree_index].arr[2].p==VOID || GetCount(nodes[tree_index].arr[0].p,depth+1)<GetCount(nodes[tree_index].arr[2].p,depth+1)) i1=0,i2=1; else i1=1,i2=2; break;
	case 2: i1=1; i2=2; break;
	}
	ref1=nodes[tree_index].arr[i1].p;
	ref2=nodes[tree_index].arr[i2].p;
	count1=GetCount(ref1,depth+1);
	count2=GetCount(ref2,depth+1);
	if(depth==tree_h-1) { //   ,      
		if(count1+count2<=LIST_SIZE) { //    
			MergeList(ref1,ref2);
			RemoveFromNode(tree_index,i2);
#if LIST_SIZE==2
			nodes[tree_index].arr[i1].v=list[ref1].v[0];
#endif
		} else
			if(abs(count1-count2)>1) { //  
			if(count1>count2) PourListR(ref1,ref2); else PourListL(ref1,ref2);
			nodes[tree_index].arr[i2].v=list[ref2].v[0];
		}
	} else {
		if(count1+count2<=3) {	//  
			MergeNode(ref1,ref2);
			RemoveFromNode(tree_index,i2);
		}
		if(abs(count1-count2)>1) { //  
			if(count1>count2) PourNodeR(ref1,ref2); else PourNodeL(ref1,ref2);
			nodes[tree_index].arr[i2].v=nodes[ref2].arr[0].v;
		}
	}
	min=nodes[tree_index].arr[0].v;
}

//=====   (   ) =====

//!  
void Show()
{
	printf("[show]\n");
	if(tree_root==VOID) printf("empty tree\n"); else Show(tree_root,0);
}

//!    
//! \param value  
void Insert(int value)
{
	printf("insert: %d\n",value);
	if(tree_root==VOID) {	//    -   
		tree_root=NewList(); tree_h=0;
		list[tree_root].count=1;
		list[tree_root].v[0]=value;
		return;
	}
	InsertSub(tree_root,0,value); 
}

//!   
//! \param value  
void Remove(int value)
{
	int n;
	printf("remove: %d\n",value);
	RemoveSub(tree_root,0,value);
	while(tree_h>0) { //      ,   
		if(nodes[tree_root].arr[1].p!=VOID) break;
		n=tree_root; tree_root=nodes[tree_root].arr[0].p;
		FreeNode(n);
		tree_h--;
	}
}


//=====    ======

//     
enum MapCode{
MAPCODE_FREE	=0,	//  
MAPCODE_USE		=1,	//  
MAPCODE_USEOK	=2,	//     
MAPCODE_ERR		=3	//  ,    
};

MapCode map[CHECK_SIZE]; //!<     

//!     ,  
//! \param tree_index   
//! \param depth 
void CheckMap(int tree_index,int depth)
{
	int n,v;
	if(depth==tree_h) {
		for(n=0; n<list[tree_index].count; n++) { 
			v=list[tree_index].v[n];
			map[v]=map[v]==MAPCODE_USE?MAPCODE_USEOK:MAPCODE_ERR;
		}
		return;
	}
	for(n=0; n<3; n++) if(nodes[tree_index].arr[n].p!=VOID) CheckMap(nodes[tree_index].arr[n].p,depth+1); else break;
}

//!     
//!   
void CheckMap()
{
	int n;
	CheckMap(tree_root,0);
	for(n=0; n<CHECK_SIZE; n++) switch(map[n]) {
	case MAPCODE_FREE: break;
	case MAPCODE_USEOK: map[n]=MAPCODE_USE; break;
	default: _asm { int 3 }
	}
}


//!   ,  
//! \param tree_index   
//! \param seed     (     )
//! \param depth 
//! \result     
int Check(int tree_index,int *seed,int depth)
{
	int n,r,t;
	if(tree_index==VOID) return -1;
	if(depth==tree_h) {
		for(n=0; n<list[tree_index].count; n++) {
			if(list[tree_index].v[n]<0 || list[tree_index].v[n]>=CHECK_SIZE) _asm { int 3 }
			if(*seed<list[tree_index].v[n]) *seed=list[tree_index].v[n]; else _asm { int 3 }
		}
		return list[tree_index].v[0];
	}
	if(nodes[tree_index].arr[1].p==VOID) _asm { int 3 }
	r=-1;
	for(n=0; n<3; n++) {
		if(nodes[tree_index].arr[n].p==VOID) break;
		t=Check(nodes[tree_index].arr[n].p,seed,depth+1);
		if(!n) r=t;
		if(nodes[tree_index].arr[n].v!=t) _asm { int 3 }
	}
	return r;
}


//!   
//!          
//!       
//!          
//!   
void Check()
{
	int value=-99;
	Check(tree_root,&value,0);
}


//=============================================================================




void main()
{
	int n,v;
	Init();
	memset(map,MAPCODE_FREE,sizeof(map));
	for(n=0;;n++) 
	{
		printf("[pass: %d]\n",n);
		v=rand()%CHECK_SIZE; map[v]=MAPCODE_USE;  Insert(v);
		v=rand()%CHECK_SIZE; map[v]=MAPCODE_FREE; Remove(v);
		if(!(n%1000)) {
			Check();
			CheckMap();
		}
		if(_kbhit()) break;
	}
	//  
	printf("wipe teee\n");
	for(n=0; n<CHECK_SIZE; n++) if(map[n]) Remove(n);
	if(tree_h) printf("error (h>0)\n"); else if(tree_root!=VOID) FreeList(tree_root);	
	//    
	for(n=0; n<LIST_LIMIT; n++) if(!isFreeList(n)) printf("leak list: %d\n\a");
	for(n=0; n<NODE_LIMIT; n++) if(!isFreeNode(n)) printf("leak node: %d\n\a");
	printf("[done]\n");
	getchar();
	getchar();
}






